

import 'package:flutter/material.dart';

class PreviewPage extends StatelessWidget {
  final List<PreviewProvider> providers;

  const PreviewPage({Key key, this.providers}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      theme: ThemeData.dark(),
      home: Scaffold(
        appBar: AppBar(
          title: Text(
            'Previews',
            style: TextStyle(
              fontSize: 14,
            ),
          ),
        ),
        body: Center(
          child: SingleChildScrollView(
            child: Column(
              children: [
                for (final provider in providers) ...provider.previews,
              ],
            ),
          ),
        ),
      ),
    );
  }
}

abstract class PreviewProvider {
  List<Preview> get previews;
}

class Preview extends StatelessWidget {
  final Widget child;
  final double height;
  final double width;
  const Preview(
      {Key key, @required this.child, this.height = 200, this.width = 200})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Container(
      height: width,
      width: height,
      child: child,
    );
  }
}
